import java.lang.Integer;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import Virheentarkistus;
/*=====================================================================
* Luokka asiakastietolomakkeen graafiseen esittmiseen ja tapahtu- 
* mien ohjaamiseen. Luokan kytt edellytt seuraavia luokkia: 
*	Asiakasrekisteri,Valikkotoiminnot. Yhteydet on asetettava 
*	asetaRekisteri()- ja asetaYhteydet()-metodeilla olion luomisen 
*	jlkeen.
*
* Kirjoittanut: Ahti Syreeni
* Pvm: 13.2.2000
=====================================================================*/

public class Lomake implements ActionListener{
	private Asiakasrekisteri 		asiakasrekisteri;
	private Valikkotoiminnot 		valikkotoiminnot;
  //----------------kyttliittymelementit----------------------------
	private TextField etunimikentt, sukunimikentt, syntympivkentt,
										syntymkuukentt,syntymvuosikentt, puhelinkentt, 
										shkpostikentt,katuosoitekentt, postinumerokentt, 
										kaupunkikentt,maakentt, sarjanumerokentt, 
										rekisteritymispivkentt, rekisteritymiskuukentt,
										rekisteritymisvuosikentt;

	private	Choice		tuote; //tuotteenvalintalista
	private Button		edellinen, seuraava, uusiLomake;			
	private Panel			lomake, nimitiedot, kontaktitiedot, syntymaika, 
										rekisteritymisaika,tuotetiedot, navigointi;
	
	//--------------------konstruktori-----------------------------------
	public Lomake(){
		//paneelien luonti 
		this.lomake= new Panel(new GridLayout(4,1));
		this.nimitiedot=new Panel(new GridLayout(4,4)); 				 	 //ylosa
		this.kontaktitiedot=new Panel(new GridLayout(4,4)); 	 	 //keskiosa
		this.tuotetiedot=new Panel(new GridLayout(3,4));  				 //alaosa
		this.navigointi=new Panel(new FlowLayout());		 //nappien asettelu
		this.syntymaika=new Panel(new GridLayout(1,3)); 			 //aikakentt
		this.rekisteritymisaika=new Panel(new GridLayout(1,3));//aikakentt
		
		//nimi- ja syntymaikatietokenttien alustus
		this.etunimikentt= new TextField(15);
		this.sukunimikentt= new TextField(20);
		this.syntympivkentt= new TextField("pvm",2);
		this.syntympivkentt.addActionListener(this);
		this.syntymkuukentt=new TextField("kk",2);
		this.syntymkuukentt.addActionListener(this);
		this.syntymvuosikentt=new TextField("vv",4);		
		this.syntymvuosikentt.addActionListener(this);
		this.syntymaika.add(syntympivkentt);
		this.syntymaika.add(syntymkuukentt);
		this.syntymaika.add(syntymvuosikentt);
		for(int i=0; i<4;i++) // listn tyhj rivi
			this.nimitiedot.add(new Label(""));		
		this.nimitiedot.add(new Label("Etunimi"));		
		this.nimitiedot.add(this.etunimikentt);		
		this.nimitiedot.add(new Label("Sukunimi"));		
		this.nimitiedot.add(this.sukunimikentt);		
		this.nimitiedot.add(new Label("Syntymaika:"));		
		this.nimitiedot.add(this.syntymaika);		
		this.nimitiedot.add(new Label(""));		
		this.nimitiedot.add(new Label(""));		
		for(int i=0; i<4;i++) // listn tyhj rivi 
			this.nimitiedot.add(new Label(""));		
		this.lomake.add(nimitiedot);
		//-----puhelinnumero,sposti,osoite ym tietokenttien alustus------
		this.puhelinkentt= new TextField(15);
		this.shkpostikentt= new TextField(20);
		this.shkpostikentt.addActionListener(this);
		this.katuosoitekentt= new TextField(15);
		this.postinumerokentt= new TextField(20);
		this.kaupunkikentt= new TextField(15);
		this.maakentt= new TextField(20);
		
		this.kontaktitiedot.add(new Label("Puhelin:"));
		this.kontaktitiedot.add(this.puhelinkentt);
		this.kontaktitiedot.add(new Label("Shkposti:"));
		this.kontaktitiedot.add(this.shkpostikentt);
		this.kontaktitiedot.add(new Label("Katuosoite:"));
		this.kontaktitiedot.add(katuosoitekentt);
		this.kontaktitiedot.add(new Label("Postinumero:"));
		this.kontaktitiedot.add(this.postinumerokentt);
		this.kontaktitiedot.add(new Label("Kaupunki:"));
		this.kontaktitiedot.add(this.kaupunkikentt);
		this.kontaktitiedot.add(new Label("Maa:"));
		this.kontaktitiedot.add(this.maakentt);
	  for(int i=0; i<4;i++) 
			this.kontaktitiedot.add(new Label(""));		
		this.lomake.add(kontaktitiedot);

		//-tuote- sarjanumero ja rekisterintiaikakenttien alustus----
		this.tuote=new Choice();
		this.sarjanumerokentt= new TextField(20);
		this.sarjanumerokentt.addActionListener(this);

		this.rekisteritymispivkentt= new TextField("pvm",2);
		this.rekisteritymispivkentt.addActionListener(this);
		this.rekisteritymiskuukentt=new TextField("kk",2);
		this.rekisteritymiskuukentt.addActionListener(this);
		this.rekisteritymisvuosikentt=new TextField("vv",4);		
		this.rekisteritymisvuosikentt.addActionListener(this);
		this.rekisteritymisaika.add(rekisteritymispivkentt);
		this.rekisteritymisaika.add(rekisteritymiskuukentt);
		this.rekisteritymisaika.add(rekisteritymisvuosikentt);
		
		this.tuotetiedot.add(new Label("Tuote:"));
		this.tuotetiedot.add(this.tuote);
		this.tuotetiedot.add(new Label("Sarjanumero:"));
		this.tuotetiedot.add(this.sarjanumerokentt);
		this.tuotetiedot.add(new Label("Rekisteritynyt:"));
		this.tuotetiedot.add(this.rekisteritymisaika);
		this.tuotetiedot.add(new Label(""));
		this.tuotetiedot.add(new Label(""));
		for(int i=0; i<4;i++) 
			this.tuotetiedot.add(new Label(""));		
		this.lomake.add(this.tuotetiedot);		
	
		//------nappulat edellinen, seuraava ja uusi lomake alustus
		this.edellinen= new Button("Edellinen");
		this.edellinen.addActionListener(this);
		this.seuraava= new Button("Seuraava");
		this.seuraava.addActionListener(this);
		this.uusiLomake=new Button ("Uusi lomake");
		this.uusiLomake.addActionListener(this);
    this.navigointi.add(new Label("Lomakkeet:"));
		this.navigointi.add(this.edellinen);
		this.navigointi.add(this.seuraava);
		this.navigointi.add(this.uusiLomake);
		this.lomake.add(navigointi);
	}
	//---------------------napilla ohjattavat toiminnot------------------
  public void seuraavaLomake(){
		/**metodi nytt aakkosjrjestyksess seuraavan lomakkeen asiakas-
			 rekisteriss*/
		this.vieRekisteriin(); //tallennetaan nykyinen lomake rekisteriin
		this.asiakasrekisteri.selaa(1,true);
		this.nytLomake();
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void edellinenLomake(){
		/**metodi nytt aakkosjrjestyksess edellisen lomakkeen asiakas-
			 rekisteriss*/
		this.vieRekisteriin();
		this.asiakasrekisteri.selaa(1,false);
		this.nytLomake();
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void uusiLomake(){
		/**metodi antaa uuden tyhjn lomakkeen ja vie sit ennen ksitellyn
			 lomakkeen asiakasrekisteriin*/
		this.uusiLomake(false);
	}
	//--------------------julkisivun anto--------------------------------
	public Panel annaJulkisivu(){
		/**palauttaa lomakkeen graavisen asettelun valmiina paneelina*/
		return this.lomake;
	}
	//-------------------------------------------------------------------
  public void nytLomake(){
		/**nytt kutsumishetkell asiakasrekisteriss ksiteltvn olevan
			 asiakkaan tiedot lomakkeella*/ 
		char[] pivys;
		if(this.asiakasrekisteri.rekisteriKoko()==0){ //rekisteriss ei 
			this.tyhjennLomake();											//nytettv
			return;
		}
		this.etunimikentt.setText(this.asiakasrekisteri.annaEtunimi());
		this.sukunimikentt.setText(this.asiakasrekisteri.annaSukunimi());
		try{
			pivys=this.asiakasrekisteri.annaSyntymaika().toCharArray();
			this.syntympivkentt.setText(""+pivys[0]+pivys[1]);
			this.syntymkuukentt.setText(""+pivys[2]+pivys[3]);
			this.syntymvuosikentt.setText(""+pivys[4]+pivys[5]
																			  +pivys[6]+pivys[7]);
		}catch(Exception e){
			this.syntympivkentt.setText("");
			this.syntymkuukentt.setText("");
			this.syntymvuosikentt.setText("");
		}
		this.puhelinkentt.setText(this.asiakasrekisteri.annaPuhelinnumero());
		this.shkpostikentt.setText(this.asiakasrekisteri.annaShkpostiosoite());
		this.katuosoitekentt.setText(this.asiakasrekisteri.annaKatuosoite());
		this.postinumerokentt.setText(this.asiakasrekisteri.annaPostinumero());
		this.kaupunkikentt.setText(this.asiakasrekisteri.annaKaupunki());
		this.maakentt.setText(this.asiakasrekisteri.annaMaa());
		this.tuote.select(this.asiakasrekisteri.annaTuote());
		this.sarjanumerokentt.setText(this.asiakasrekisteri.annaSarjanumero());
		pivys=this.asiakasrekisteri.annaRekisteritymispiv().toCharArray();
		try{
			this.rekisteritymispivkentt.setText(""+pivys[0]+pivys[1]);
			this.rekisteritymiskuukentt.setText(""+pivys[2]+pivys[3]);
			this.rekisteritymisvuosikentt.setText(""+pivys[4]+pivys[5]
																								+pivys[6]+pivys[7]);
		}catch(Exception e){
			this.rekisteritymispivkentt.setText("");
			this.rekisteritymiskuukentt.setText("");
			this.rekisteritymisvuosikentt.setText("");
		}
		this.tarkistaPivykset();
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void asetaRekisteri(Asiakasrekisteri rekisteri){
		/**asettaa yhteyden kytettvn asiakasrekisteriin*/	
		this.asiakasrekisteri=rekisteri;
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void asetaYhteydet(Valikkotoiminnot v){
		/**asettaa yhteyden Valikkotoiminnot-luokkaan 
			 tallennuksen kirjanpitoa varten*/
		this.valikkotoiminnot=v;
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public void vieRekisteriin(){
		/**metodi vie ksiteltvn lomakkeen rekisteriin, mikli se ei ole
			 tyhj*/
		String pivys;
		if(this.tyhjLomake()) //ei tyhji lomakkeita rekisteriin
			return; 
		this.asiakasrekisteri.asetaEtunimi(this.etunimikentt.getText());
		this.asiakasrekisteri.asetaSukunimi(this.sukunimikentt.getText());
		pivys=this.muotoilePivys(this.syntympivkentt.getText(),
																 this.syntymkuukentt.getText(),
																 this.syntymvuosikentt.getText()); 
		this.asiakasrekisteri.asetaSyntymaika(pivys);
		this.asiakasrekisteri.asetaPuhelinnumero(this.puhelinkentt.getText());
		this.asiakasrekisteri.asetaShkpostiosoite(this.shkpostikentt.getText());
		this.asiakasrekisteri.asetaKatuosoite(this.katuosoitekentt.getText());
		this.asiakasrekisteri.asetaPostinumero(this.postinumerokentt.getText());
		this.asiakasrekisteri.asetaKaupunki(this.kaupunkikentt.getText());
		this.asiakasrekisteri.asetaMaa(this.maakentt.getText());
		this.asiakasrekisteri.asetaTuote(this.tuote.getSelectedItem());
		this.asiakasrekisteri.asetaSarjanumero(this.sarjanumerokentt.getText());
		pivys=this.muotoilePivys(this.rekisteritymispivkentt.getText(),
																 this.rekisteritymiskuukentt.getText(),
																 this.rekisteritymisvuosikentt.getText()); 
		this.asiakasrekisteri.asetaRekisteritymispiv(pivys);
		this.asiakasrekisteri.vieRekisteriin();
	}
	//---------------------apumetodit------------------------------------
  private void uusiLomake(boolean edellinenTuhotaan){
		/**metodi antaa uuden lomakkeen. Parametrista riippuu, tuhotaanko
			 edellinen lomake*/
		if(!edellinenTuhotaan)
			this.vieRekisteriin(); //tallennetaan ksiteltv asiakasrekisteriin
		this.asiakasrekisteri.uusiAsiakas();
		this.etunimikentt.setText(""); 
		this.sukunimikentt.setText("");
		this.syntympivkentt.setText("");
		this.syntymkuukentt.setText("");
		this.syntymvuosikentt.setText("");
		this.puhelinkentt.setText("");
		this.shkpostikentt.setText("");
		this.katuosoitekentt.setText("");
		this.postinumerokentt.setText("");
		this.kaupunkikentt.setText("");
		this.maakentt.setText("");
		this.sarjanumerokentt.setText("");
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public void tyhjennLomake(){
		/**tyhjent koko lomakkeen, mys rekisteritymispivkentt*/ 
		this.uusiLomake(true);
		this.rekisteritymispivkentt.setText("");
		this.rekisteritymiskuukentt.setText("");
		this.rekisteritymisvuosikentt.setText("");
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
 	private void tarkistaPivykset(){
		/**tarkistaa kaikkien lomakkeen pivyskenttien oikeellisuuden ja
			 merkitsee virheelliset pivykset*/		
		Virheentarkistus.pivyskentt(this.syntympivkentt,true);
		Virheentarkistus.pivyskentt(this.syntymkuukentt,false);
		Virheentarkistus.vuosikentt(this.syntymvuosikentt);
		Virheentarkistus.pivyskentt(this.rekisteritymispivkentt,true);
		Virheentarkistus.pivyskentt(this.rekisteritymiskuukentt,false);
		Virheentarkistus.vuosikentt(this.rekisteritymisvuosikentt);
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void lisTuote(String uusiTuote){
		/**lis tuotteen tuotelistaan*/
		this.tuote.add(uusiTuote);
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void poistaTuote(String tuote){
		/**poistaa annetun tuotteen tuotelistalta*/
		this.tuote.remove(tuote);
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void tarkistaSarjanumero(){
		/**tarkistaa sarjanumerokentn sarjanumeron*/
		String sarjanumero=this.sarjanumerokentt.getText();
		if(!this.asiakasrekisteri.asetaSarjanumero(sarjanumero))
			this.sarjanumerokentt.selectAll();
		else
			this.sarjanumerokentt.select(0,0);
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	private boolean tyhjLomake(){
		/**ilmoittaa, onko lomake tyhj, tuotevalikkossa ja
			 rekisteritymispivkentiss saa olla arvoja ja silti
			 lomake katsotaan tyhjksi*/			  
		if(!this.etunimikentt.getText().equals(""))
			return false;
		if(!this.sukunimikentt.getText().equals(""))
			return false;
		if(!this.syntympivkentt.getText().equals(""))
			return false;
		if(!this.syntymkuukentt.getText().equals(""))
			return false;
		if(!this.syntymvuosikentt.getText().equals(""))
			return false;
		if(!this.puhelinkentt.getText().equals(""))
			return false;
		if(!this.shkpostikentt.getText().equals(""))
			return false;
		if(!this.katuosoitekentt.getText().equals(""))
			return false;
		if(!this.postinumerokentt.getText().equals(""))
			return false;
		if(!this.kaupunkikentt.getText().equals(""))
			return false;
		if(!this.maakentt.getText().equals(""))
			return true;
		if(!this.sarjanumerokentt.getText().equals(""))
			return false;
		return true;
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public String muotoilePivys(String piv, String kuu, String vuosi){
		/**muotoilee tekstikentist saadun pivyksen asiakasrekisterin hyvk-
			 symksi merkkijonoesitykseksi*/
		String palautettava="";
		if(piv.length()==0)
			palautettava+="00";
		if(piv.length()==1)
			palautettava+="0"+piv;
		if(piv.length()>=2)
			palautettava+=piv;
		if(kuu.length()==0)
			palautettava+="00";
		if(kuu.length()==1)
			palautettava+="0"+kuu;
		if(kuu.length()>=2)
			palautettava+=kuu;
		if(vuosi.length()==0)
			palautettava+="0000";
		if(vuosi.length()==1)
			palautettava+="200"+vuosi;
		if(vuosi.length()==2)
			palautettava+="19"+vuosi;
		if(vuosi.length()==3)
			palautettava+="1"+vuosi;
		if(vuosi.length()>=4)
			palautettava+=vuosi;
		return palautettava;
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void actionPerformed(ActionEvent tapahtuma){
		/**tapahtumaohjaus,toimintojen jako luokan metodeille*/
		Object aiheuttaja=tapahtuma.getSource();

		this.valikkotoiminnot.tehtyMuutoksia(); //tarve tallentaa
		if(aiheuttaja==this.syntympivkentt || 
			 aiheuttaja==this.syntymkuukentt || 
			 aiheuttaja==this.rekisteritymispivkentt || 
			 aiheuttaja==this.rekisteritymiskuukentt)
		  this.tarkistaPivykset(); 		
		else if(aiheuttaja==this.syntymvuosikentt || 
						aiheuttaja==this.rekisteritymisvuosikentt)
			this.tarkistaPivykset();	
		else if(aiheuttaja==this.sarjanumerokentt)
			this.tarkistaSarjanumero();
		else if(aiheuttaja==this.edellinen)
			this.edellinenLomake();
		else if(aiheuttaja==this.seuraava)
			this.seuraavaLomake();
		else if(aiheuttaja==this.uusiLomake)
			this.uusiLomake();
  }
}
