import java.awt.*;
import java.awt.event.*;

/*=====================================================================
* Aino-asiakasrekisterin pohjelmaluokka. Luokan kytt edellytt 
* Luokkia: Asiakasrekisteri,Lomake,Tietokantapalvelut,Tuotteet,
*	Valikkotoiminnot.	

* Kirjoittanut: Ahti Syreeni
* Pvm: 19.2.2000
* muutokset:
* ongelmat:  
======================================================================*/  
public class Aino extends Frame implements ActionListener{
	private Asiakasrekisteri asiakasrekisteri;
	private Lomake lomake;
	private Tietokantapalvelut tietokantapalvelut;
	private Tuotteet tuotteet;
	private Valikkotoiminnot valikot;
	private Panel tietokantaJaTuotteet, tytepaneeli;
	//--------------------------konstruktori-----------------------------
	public Aino (){
		this.asiakasrekisteri=new Asiakasrekisteri();
		this.lomake= new Lomake();
		this.tietokantapalvelut= new Tietokantapalvelut();
		this.tuotteet= new Tuotteet();
		this.valikot=new Valikkotoiminnot();
		setLayout(new BorderLayout(25,5)); //koko ruudun asettelu

		//yhdistetn hakupalveluelementit ja tuotehallintaelementit
		//yhdeksi paneliksi ruudun oikeaan reunaan
		this.tietokantaJaTuotteet=new Panel(new BorderLayout(10,0));
		this.tytepaneeli=new Panel(); //alimmat kentt irti ruudun 
																	 //alareunasta
		this.tietokantaJaTuotteet.add("Center",
														this.tietokantapalvelut.annaJulkisivu());
		this.tietokantaJaTuotteet.add("South",this.tuotteet.annaJulkisivu());
		//erottimeksi vierityspalkki
		this.tietokantaJaTuotteet.add("West",
													 new Scrollbar(Scrollbar.VERTICAL, 0, 0, 0, 0));

		add("Center",this.lomake.annaJulkisivu());
		add("East",this.tietokantaJaTuotteet);
		add("South",this.tytepaneeli);
		//asetetaan tarvittavat yhteydet kyttliittymolioiden vlille
		this.lomake.asetaRekisteri(this.asiakasrekisteri);
		this.lomake.asetaYhteydet(this.valikot);
		this.tietokantapalvelut.asetaYhteydet(this.lomake, this.asiakasrekisteri,
																					this.tuotteet,this.valikot);
		this.tuotteet.asetaYhteydet(this.tietokantapalvelut, 
																this.asiakasrekisteri, this.lomake, 
																this.valikot);
		this.valikot.asetaYhteydet(this.lomake,
															 this.tietokantapalvelut,this.tuotteet);
		this.valikot.asetaRekisteri(this.asiakasrekisteri);
		this.asiakasrekisteri=null; //tietokantapalvelut pit tst edes huolta 
																//asiakasrekisterin viitteist
		setMenuBar(this.valikot.annaValikko());

		SuljeSovellus lopetus=new SuljeSovellus(); //lopetus voidaan sulkea mys
		lopetus.asetaYhteydet(this.valikot);       //ikkunan ylkulmasta
		addWindowListener(lopetus);	

  }
	public void actionPerformed(ActionEvent tapahtuma){} 
	//--------------------------pohjelma-----------------------------
  public static void main(String[] args){
		Aino aino=new Aino();
		aino.setTitle("Aino -asiakasrekisteri");
		aino.pack();
		aino.setVisible(true);
  }
}
//-------------------------------------------------------------------
//---------------------luokka ikkunan sulkemiseen--------------------
class SuljeSovellus extends WindowAdapter{
	private Valikkotoiminnot valikkotoiminnot;
	public void asetaYhteydet(Valikkotoiminnot v){
		this.valikkotoiminnot=v;
	}
	public void windowClosing(WindowEvent tapahtuma){
		this.valikkotoiminnot.lopetus();
		//kytetn valikkotoimintojen lopetusmetodia, jotta voidaan
		//varoittaa tallennuksesta
	}
}