import java.io.*;
/*====================================================================
*Luokka tuotteen mallintamista varten.
*
*Kirjoittanut: Ahti Syreeni
*Pvm: 28.1.2000
=====================================================================*/

public class Tuote  implements Serializable{
	private final int alinSallittuVuosi=1900;//alin sallittu rekiste- 
 	private Asiakas omistaja;								 //ritymisvuosi
  private String tuote;
  private String rekisteritymispiv;
  private String sarjanumero;
  //------------------------------------------------------------------
  public Tuote(){
		this.rekisteritymispiv=" ";
		this.sarjanumero=" ";
  }
  public Tuote(String tuote){
  	this.tuote=tuote;
		this.rekisteritymispiv=" ";
		this.sarjanumero=" ";
  }
  //------------------------------------------------------------------
  public String annaTuote(){
		return this.tuote;
  }
  public String annaRekisteritymispiv(){
		return this.rekisteritymispiv;
  }
  public String annaSarjanumero(){
  	return this.sarjanumero;
  }
  public Asiakas annaOmistaja(){
		return this.omistaja;
  }
  public void asetaTuote(String tuote){
		this.tuote=tuote.trim();
  }
  public void asetaRekisteritymispiv(String pivys){
		this.rekisteritymispiv=pivys.trim();
  }
  public void asetaSarjanumero(String sarjanumero){
		this.sarjanumero=sarjanumero.trim();
  }
	public boolean pivyksessVirhe(){
	/**metodi tarkistaa, onko rekisteritymispivkentn pivys 
		 oikein: pivn on oltava vlill 1-31, kuukauden 1-12 ja
		 vuoden pit olla yli luokan vakion "alinSallittuVuosi".
		 Metodi kytt luokan Virheentarkistus palvelua */
			 
		if(Virheentarkistus.pivys(this.rekisteritymispiv,
																 this.alinSallittuVuosi))
			return false;
		else 
			return true;
	}
  public void asetaOmistaja(Asiakas omistajaviite){
		/** Metodin avulla voi asettaa viitteen tuotteen omistajaan,
				joka on Asiakas -luokan ilmentym, mikli sovelluksessa
				yhteytt tarvitaan*/ 
		this.omistaja=omistajaviite;
  }
	public String toString(){
		return ("tuote:"+this.tuote+",rekisterimispiv:"
						+this.rekisteritymispiv+", sarjanumero:"
						+this.sarjanumero);
	}
}
